import { Context, Schema, Service } from 'koishi';
import { Client } from './telemetry/client';
export declare const name = "lovemilk-telemetry";
export declare const inject: string[];
export declare const usage = "<a class=\"el-button\" href=\"/lovemilk-telemetry/EULA\">Lovemilk Telemetry \u7EC8\u7AEF\u7528\u6237\u534F\u8BAE & \u9690\u79C1\u653F\u7B56</a>";
export interface Config {
    telemetryReconnectInterval: number;
    telemetryUseTimeoutMoreThan: number;
    telemetryMaxTry: number;
    telemetryCoolDown: number;
    axiosConfig: boolean;
    axiosTimeout: number;
}
export declare const Config: Schema<Config>;
declare module '@koishijs/plugin-console' {
    interface Events {
        'lovemilk-telemetry/eula'(): string;
    }
}
export declare function apply(ctx: Context, config: Config): Promise<void>;
export declare class LovemilkTelemetry extends Service {
    private clients;
    constructor(ctx: Context, config: Config);
    private wavehand;
    protected stop(): Promise<void>;
    createClient(pluginCtx: Context, pluginConfig: any, enpoint: string | URL): Client;
}
declare module 'koishi' {
    interface Context {
        lovemilkTelemetry: LovemilkTelemetry;
    }
}
export * from './telemetry/client';
export * from './telemetry/types';
