import { Context } from "koishi";
import { ClientType, TelemetryEvent, SuccessServerResp, ErrorServerResp } from "./types";
import { Config } from "..";
export declare function makeEvent<T extends TelemetryEvent>(name: T['name'], clientType: ClientType, mid: string, data?: T['data']): T;
export declare function getErrorDetail(resp: ErrorServerResp): string;
export declare class Client {
    readonly type = ClientType.koishi;
    readonly mid: string;
    readonly pluginCtx: Context;
    readonly pluginConfig: any;
    private readonly ctx;
    private static config;
    private endpoint;
    private connection;
    readonly events: TelemetryEvent[];
    private connected;
    private disabled;
    private static timeout;
    private heartbeatInterval;
    private heartbeatTimeoutID;
    private isReconnecting;
    private lastReconnect;
    private reconnectTried;
    private AutoReconnect;
    onSend: (event: TelemetryEvent, eventHistory: TelemetryEvent[]) => void;
    constructor(ctx: Context, pluginCtx: Context, pluginConfig: any, endpoint: string | URL);
    static _setConfig(config: Config): void;
    isConnected(): boolean;
    appendEventHistory(eventOrevents: TelemetryEvent | TelemetryEvent[]): void;
    enable(): void;
    disable(): void;
    private heartbeat;
    connect(): Promise<undefined | SuccessServerResp | ErrorServerResp>;
    disconnect(code?: number, reason?: string): Promise<void>;
    sendEvent<T extends TelemetryEvent>(name: T['name'], data?: T['data'], ignoreResp?: boolean): Promise<undefined | SuccessServerResp | ErrorServerResp>;
}
